﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.ListGraphic
{

    /// <summary>
    /// 変数を見つけたら、マーカーを頭に付けます。
    /// </summary>
    public abstract class Actions_AppendMarker
    {

        public static void AppendMarker(
            string src,      //＜サンプル＞ chrSymbol .. "_" .. gName
            out string dst,
            string file,
            int lineCount
            )
        {
            //------------------------------
            //
            //  式部分の分割
            //
            //  chrSymbol .. "_" .. gName
            //  ↓
            //  ・chrSymbol
            //  ・..
            //  ・"_"
            //  ・..
            //  ・gName
            //
            //------------------------------

            List<string> tokenList = Actions_ConcatTokenizer.Tokenize(src);
            Actions_ConcatTokenizer.ShowDebug(tokenList);


            //Actions_MarkerExpander.TryExpandMarker(tokenList, );

            StringBuilder newSahenB = new StringBuilder();
            foreach (string token in tokenList)
            {
                if (Char.IsWhiteSpace(token[0]))
                {
                    // 空白か？
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    newSahenB.Append(token);
                }
                else if ('"' == token[0])
                {
                    // リテラル文字列か？
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    newSahenB.Append(token);
                }
                else if (Char.IsLetter(token[0]))
                {
                    // 変数名か？
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    // 頭にマークを付加します。
                    newSahenB.Append(Actions_Variablename.Marking(token, file, lineCount));
                }
                else
                {
                    // 記号か？
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    newSahenB.Append(token);
                }
            }
            System.Console.WriteLine("　newSahenB＝[" + newSahenB + "]");

            dst = newSahenB.ToString();
        }


    }
}
