﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.ListGraphic
{


    public abstract class Actions_BlacketOpener
    {

        /// <summary>
        /// ブラケット（[ ]）を見かけたら、３分割します。
        /// 
        ///------------------------------
        ///
        ///  G.src[ ★ ]
        ///  ↓
        /// (A)G.src[
        /// (B)★
        /// (C)]
        ///
        ///------------------------------
        ///
        ///  想定するケース
        ///
        ///  ・ G.cursor
        ///  ・ G.src["gauge"]
        ///  ・ G.src [ chrSymbol .. "_g101_1"]
        ///  ・ G.src [ chrSymbol .. "_" .. gName]
        ///  
        ///------------------------------
        /// 
        /// a[].b[] ←こういう形は現版では考えません。
        /// 
        ///------------------------------
        /// </summary>
        /// <param name="sahen"></param>
        /// <param name="sahenA"></param>
        /// <param name="sahenB"></param>
        /// <param name="sahenC"></param>
        /// <param name="file"></param>
        /// <param name="lineCount"></param>
        /// <returns></returns>
        public static bool OpenBlacket(string sahen, out string sahenA, out string sahenB, out string sahenC, string file, int lineCount)
        {
            bool successful = false;
            sahenA = "";
            sahenB = "";
            sahenC = "";

            int open = sahen.IndexOf('[');

            if (1 <= open)
            {
                // [ が開きました。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                int close = sahen.LastIndexOf(']');
                if (open < close)
                {
                    // ] で閉じられています。
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    sahenA = sahen.Substring(0, open + 1);
                    sahenB = sahen.Substring(open + 1, close - (open + 1));
                    sahenC = sahen.Substring(close, sahen.Length - close);
                    successful = true;
                    //System.Console.WriteLine("左辺　Ａ＝[" + sahenA + "]　★Ｂ＝[" + sahenB + "]　Ｃ＝[" + sahenC + "]");
                }
            }
            //else
            //{
            //    //(B)
            //    Regex rY = new Regex(
            //        @"\s*[^\[]+\[\s*" +    //＜サンプル＞ G.src[
            //        @"" +
            //        @"" +
            //        @""
            //        , RegexOptions.Compiled | RegexOptions.Singleline);
            //}

            return successful;
        }

    }
}
