﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Data;

namespace Xenon.ListGraphic
{
    public abstract class Actions_MarkerExpander
    {

        public static void TryExpandMarker(List<string> tokenList, LocalTable localTable, out string expanded)
        {
            //------------------------------------------------------------
            //
            //  次のくり返しを発見したとき、マーカーを展開します。
            //
            // (1) {
            // (2) "～"
            // (3) }
            // (4) aaa
            //
            //------------------------------------------------------------

            int matchPhase = 0;
            List<string> buffer = new List<string>();

            List<string> result = new List<string>();
            foreach(string token in tokenList)
            {
                if (matchPhase==0 && "{" == token)
                {
                    buffer.Add(token);
                    matchPhase++;
                }
                else if (matchPhase == 1 && '"'==token[0])
                {
                    buffer.Add(token);
                    matchPhase++;
                }
                else if (matchPhase == 2 && "}" == token)
                {
                    buffer.Add(token);
                    matchPhase++;
                }
                else if (matchPhase == 3 && Char.IsLetter(token[0]))
                {
                    // マーカーでした。
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    buffer.Add(token);

                    // 結合
                    StringBuilder markerAndName = new StringBuilder();
                    foreach(string token2 in buffer)
                    {
                        markerAndName.Append(token2);
                    }
                    buffer.Clear();

                    string mkFile;
                    int mkLineCount;
                    string mkName = Actions_Variablename.Demarking(markerAndName.ToString(), out mkFile, out mkLineCount);

                    DataRow row = localTable.FindLocalDecralation(mkFile, mkName, mkLineCount);
                    if (null != row)
                    {
                        string value = (string)row["Value"];

                        result.Add(value);
                    }
                    else
                    {
                        foreach (string token2 in buffer)
                        {
                            result.Add(token2);
                        }
                        buffer.Clear();
                    }

                    matchPhase = 0;
                }
                else
                {
                    // マーカー以外でした。
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (string token2 in buffer)
                    {
                        result.Add(token2);
                    }
                    buffer.Clear();

                    result.Add(token);
                }
            }

            StringBuilder sb = new StringBuilder();
            foreach (string s in result)
            {
                sb.Append(s);
            }
            expanded = sb.ToString();
        }
    }
}
