﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Text.RegularExpressions;
using System.Data;

namespace Xenon.ListGraphic
{

    /// <summary>
    /// 変数名
    /// </summary>
    public abstract class Actions_Variablename
    {

        /// <summary>
        /// 変数展開。
        /// 
        /// gName
        /// ↓
        /// "銀"
        /// 
        /// </summary>
        /// <returns></returns>
        public static bool ExpandVariable(string currentFile, int currentLineCount, string variableName, out string variableValue, LocalTable report_Local, out string errorMessage )
        {
            bool successful = true;
            variableValue = variableName;
            errorMessage = "";

            //System.Console.WriteLine("★variableName=[" + variableName + "]");

            string mkFile;
            int mkLineCount;
            string mkName = Actions_Variablename.Demarking(variableName, out mkFile, out mkLineCount);

            if ("" == mkFile && 0 == mkLineCount)
            {
                mkFile = currentFile;
                mkLineCount = currentLineCount;
            }


            //------------------------------
            // 検索：ローカル変数
            //------------------------------
            DataRow localRow = report_Local.FindLocalDecralation(mkFile, mkName, mkLineCount);
            //DataRow localRow = this.Report_Local.FindLocalDecralation(program1, sahen, line1);

            if (null == localRow)
            {
                // ローカル変数が使われているが、関数内には　該当するローカル変数はなかった。

                errorMessage = "Error(Name):　変数「" + variableName + "」が使われていましたが、該当するローカル変数はありませんでした。";
                successful = false;
                goto gt_EndMethod;
            }

            variableValue = (string)localRow["Value"];

        gt_EndMethod:
            return successful;
        }

        /// <summary>
        /// 
        /// "あいうえお" .. aaa .. "かきくけこ"
        /// ↓
        /// "あいうえお" .. {"C:\aaa\bbb.lua*131"}aaa .. "かきくけこ"
        /// 
        /// </summary>
        /// <param name="src"></param>
        /// <param name="file"></param>
        /// <param name="lineCount"></param>
        /// <returns></returns>
        public static string Marking(string src, string file, int lineCount)
        {
            //return src;

            StringBuilder result1 = new StringBuilder();

            if (src.Length <= 0)
            {
                goto gt_EndMethod;
            }

            //System.Console.WriteLine("┏━┓Marking　src=[" + src + "]");

            bool isFirst = true;
            string rest = src;
            StringBuilder bufToken = new StringBuilder();
            char preChar = ' ';

            while(0<rest.Length)
            {
                bool literal = false;

                //------------------------------
                // リテラル文字列の退避
                //------------------------------
                int subIndex = 0;
                foreach (char ch in rest)
                {

                    if (literal)
                    {
                        //System.Console.WriteLine("○ch=" + ch);
                        result1.Append(ch);

                        if ('"' == ch && '\\' != preChar)
                        {
                            literal = false;
                        }
                    }
                    else
                    {
                        if ('"' == ch && '\\'!=preChar)
                        {
                            literal = true;

                            if (!isFirst)
                            {
                                // トークンをフラッシュ
                                string dstToken = Actions_Variablename.Marking_EndToken(bufToken.ToString(), file, lineCount);
                                //System.Console.WriteLine("┷TokenFlush　dstToken=[" + dstToken + "]");
                                result1.Append(dstToken);
                                bufToken.Clear();
                            }

                            //System.Console.WriteLine("◎ch=" + ch);
                            result1.Append(ch);
                        }
                        else if (Char.IsWhiteSpace(ch))
                        {

                            if (!isFirst)
                            {
                                // トークンをフラッシュ
                                string dstToken = Actions_Variablename.Marking_EndToken(bufToken.ToString(), file, lineCount);
                                //System.Console.WriteLine("┷TokenFlush　dstToken=[" + dstToken + "]");
                                result1.Append(dstToken);
                                bufToken.Clear();
                            }

                            //System.Console.WriteLine("◎ch=" + ch);
                            result1.Append(ch);
                        }
                        else
                        {
                            //------------------------------
                            // リテラルでも、スペースでもない
                            //------------------------------

                            // トークンをバッファー
                            //System.Console.WriteLine("│buf:ch=" + ch);
                            bufToken.Append(ch);

                            preChar = ch;
                            subIndex++;
                            break;
                        }
                    }

                    isFirst = false;
                    preChar = ch;
                    subIndex++;
                }

                // 残り
                rest = rest.Substring(subIndex, rest.Length - subIndex);
            }

            // endToken処理（残処理）
            if (0<bufToken.Length)
            {
                string dstToken = Actions_Variablename.Marking_EndToken(bufToken.ToString(), file, lineCount);
                //System.Console.WriteLine("┷EndTokenFlush　dstToken=[" + dstToken + "]");
                result1.Append(dstToken);
                bufToken.Clear();
            }

            //System.Console.WriteLine("┗━┛Marking　dst=[" + result1.ToString() + "]");

        gt_EndMethod:
            return result1.ToString();
        }

        private static string Marking_EndToken(string srcToken, string file, int lineCount)
        {
            string dstToken;

            if (0 < srcToken.Length)
            {
                // それが変数名か、演算子か、括弧か、それ以外のキーワードかの判断は？
                if (Char.IsLetter(srcToken.First()))
                {
                    // キーワードなら変数名とします。

                    // ※このテーブルでは、事前に変数を展開しておくことはできません。式をそのまま格納します。
                    // ※変数が、どの関数にあったものなのか記憶しておきたい。

                    //------------------------------
                    //
                    //  ＜サンプル＞  {"C:\aaa\bbb.lua*12"}
                    //
                    //------------------------------
                    StringBuilder sb = new StringBuilder();
                    sb.Append(@"{""");
                    sb.Append(file);
                    sb.Append(@"*");
                    sb.Append(lineCount);
                    sb.Append(@"""}");
                    sb.Append(srcToken);
                    dstToken = sb.ToString();

                    //System.Console.WriteLine("┼EndToken src=[" + srcToken + "]　dst=[" + dstToken + "]");
                }
                else
                {
                    dstToken = srcToken;
                }
            }
            else
            {
                dstToken = srcToken;
            }

            return dstToken;
        }

        /// <summary>
        /// マーキング解除
        /// 
        /// マーキング　→　{"ファイル*行番号"}
        /// </summary>
        /// <param name="src"></param>
        /// <returns></returns>
        public static string Demarking(string src, out string file, out int lineCount)
        {
            //return src;
            file = "";
            lineCount = 0;

            //System.Console.WriteLine("┏━┓Demarking　src=[" + src + "]");

            //------------------------------
            //
            //  ＜サンプル＞  {"C:\aaa\bbb.lua*12"}
            //
            //------------------------------

            Regex r = new Regex(
                @"\{"""+      //＜サンプル＞ {"
                @"([^\*]+)"+  //＜サンプル＞ C:\aaa\bbb.lua
                @"\*"+      //＜サンプル＞ *
                @"(\d+)"+     //＜サンプル＞ 12
                @"""\}"+      //＜サンプル＞ "}
                @"(.+)"     //＜サンプル＞ gName
                ,RegexOptions.Singleline
                );

            Match m = r.Match( src);

            string dst = src;

            while(m.Success)
            {
                file = m.Groups[1].Value;

                int num;
                if(int.TryParse( m.Groups[2].Value, out num))
                {
                }

                lineCount = num;
                dst = m.Groups[3].Value;

                m = r.Match(dst);
            }

            //System.Console.WriteLine("┗━┛Demarking　dst=[" + dst+"]");
            return dst;
        }

    }
}
